#!/usr/bin/php -q
<?
/* Simple voicemail for the Yate PHP interface
   To test add in regexroute.conf

   ^NNN$=external/nodata/vmail.php

   where NNN is the number you want to assign to voicemail
*/
require_once("libyate.php");

/* Always the first action to do */
Yate::Init();

/* Install a handler for the engine generated timer message */
Yate::Install("chan.dtmf",10);
Yate::Install("chan.notify");

$ourcallid = "external/" . uniqid(rand(),1);
$partycallid = "";
$state = "";

/* The main loop. We pick events and handle them */
for (;;) {
    $ev=Yate::GetEvent();
    /* If Yate disconnected us then exit cleanly */
    if ($ev == "EOF")
        break;
    /* Empty events are normal in non-blocking operation.
       This is an opportunity to do idle tasks and check timers */
    if ($ev == "")
        continue;
    /* If we reached here we should have a valid object */
    switch ($ev->type) {
	case "incoming":
	    Yate::Output("PHP Message: " . $ev->name . " our id: " . $ev->params["id"] . " target id: " . $ev->params["targetid"]);
	    switch ($ev->name) {
		case "call.execute":
		    $partycallid = $ev->params["id"];
		    $ev->params["targetid"] = $ourcallid;
		    $ev->handled = true;
		    // we must ACK this message before dispatching a call.answered
		    $ev->Acknowledge();

		    $m = new Yate("call.answered");
		    $m->params["id"] = $ourcallid;
		    $m->params["targetid"] = $partycallid;
		    $m->Dispatch();

		    $state = "prompt";
		    $m = new Yate("chan.attach");
		    $m->params["source"] = "wave/play//tmp/test.slin";
		    $m->Dispatch();

		    // we already ACKed this message
		    continue;
		case "chan.notify":
		    if($ev->params["id"] == $ourcallid){
		    $m=new Yate("chan.text");
		    $m->params["id"]= $ourcallid;
		    $m->params["targetid"]= $partycallid;
		    $m->params["text"] = "something";
		    $m->Dispatch();
		/*    switch ($state) {
		    case "call":
			$m = new Yate("attach");
			$m->params["maxlen"] = 50000;
			$m->params["consumer"] = "wave/record//tmp/xxx.slin";
			$m->Dispatch();
			$state = "record";
			break;
		    case "":*/
		    $ev->handled = true;
		    }
		    break;
		case "chan.dtmf":
		    if ($ev->params["targetid"] == $ourcallid )
		    {
			if ($ev->params["text"] == "1" && $state == "call")
			{
			    $m = new Yate("chan.attach");
			    $m->params["source"] = "wave/play//tmp/test.slin";
			    $m->params["notify"] = $ourcallid;
			    $m->Dispatch();
			 }       	    	
			elseif ($ev->params["text"] == "2" && $state == "call")
			{
			    $m = new Yate("chan.attach");
			    $m->params["maxlen"] = 50000;
			    $m->params["consumer"] = "wave/record//tmp/xxx.slin";
			    $m->params["notify"] = $ourcallid;
			    $m->Dispatch();
			}
			elseif ($ev->params["text"] == "3" && $state == "call")
			{
			    $m = new Yate("chan.attach");
			    $m->params["source"] = "wave/play//tmp/xxx.slin";
			    $m->params["notify"] = $ourcallid;
			    $m->Dispatch();
			}
			$ev->handled = true;
		    }
		    break;
		    
	    }
	       
	    /* This is extremely important.
	       We MUST let messages return, handled or not */
	    $ev->Acknowledge();
	    break;
	case "answer":
	    Yate::Output("PHP Answered: " . $ev->name . " id: " . $ev->id);
	    break;
	case "installed":
	    Yate::Output("PHP Installed: " . $ev->name);
	    break;
	case "uninstalled":
	    Yate::Output("PHP Uninstalled: " . $ev->name);
	    break;
	default:
	    Yate::Output("PHP Event: " . $ev->type);
    }
}

Yate::Output("PHP: bye!");

/* vi: set ts=8 sw=4 sts=4 noet: */
?>
